{% extends 'base.html.twig' %}

{% block title %}{{ group.title }} Details{% endblock %}

{% block body %}

    <!--{{ dump(group) }}-->

    <div style="background-color: #f8f9fc; min-height: 100%">

        {% set total = 0 %}
        {% set paymentProgress = 0 %}
        {% set paidTotal = 0 %}
        {% for p in group.payments %}
            {% set total = total + p.amount %}
            {% if p.isPaid == true %}
                {% set paidTotal = paidTotal + p.amount %}
            {% endif %}
            {% set paymentProgress = 100 * paidTotal / total %}
        {% endfor %}


        <div class="container-fluid px-5">
            <div class="row">

                <div class="col-5 mb-5 mt-5">
                    <a class="mr-4" href="{{ path("app_home") }}"><i class="fas fa-chevron-circle-left fa-2x text-gray-300"></i></a>
                    <h1 class="font-weight-bold d-inline">{{ group.title }}</h1>
                </div>
                <div class="col-7 mb-5 mt-5">
                    <h5 class="font-weight-light" style="position: absolute;top: 50%;right: 20px;transform: translateY(-50%);">Connecté en tant que <strong>{{ app.user.firstName }} {{ app.user.lastName }}</strong></h5>
                </div>

                <div class="col-12">
                    <h6>Progression des remboursements</h6>
                    <div class="progress mb-5 shadow">
                        <div class="progress-bar bg-success" role="progressbar" style="width: {{ paymentProgress }}%" aria-valuenow="{{ paymentProgress }}" aria-valuemin="0" aria-valuemax="100"></div>
                    </div>
                </div>

                <div class="col-lg-5 mb-4">
                    <h2 class="mb-4 font-weight-light">Total: {{ total }}€</h2>

                    <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <h6 class="m-0 font-weight-bold text-success">Les Paiements</h6>
                        </div>
                            <div class="card-body p-0">
                                {% if group.payments is empty %}
                                    <p class="ml-3 my-3">Il n'y a pas de paiements pour le moment</p>
                                {% endif %}
                                {% for p in group.payments %}
                                    {% set total = total + p.amount %}
                                    <div class="row no-gutters align-items-center border-bottom px-4 py-3" style="border-left: 5px solid {% if p.isPaid == true %}#28a745{% else %}#dc3545{% endif %}">
                                        <div class="col mr-2">
                                            <div class="text-xs font-weight-bold text-uppercase mb-1">{{ p.title }}</div>
                                            <div class="h5 mb-0 font-weight-light text-gray-800">{{ p.userWhoNeedToPay.firstName }} {{ p.userWhoNeedToPay.lastName }} {% if p.isPaid == true %}devait{% else %}doit{% endif %} {{ p.amount }}€ à {{ p.userWhoPaid.firstName }} {{ p.userWhoPaid.lastName }}</div>
                                        </div>
                                        <div class="col-auto">
                                            <button type="button" data-toggle="modal" data-target="#{{ p.id }}" class="btn {% if p.isPaid == true %}btn-outline-success{% else %}btn-outline-danger{% endif %}">Voir les détails</button>
                                        </div>
                                    </div>
                                {% endfor %}
                            </div>
                    </div>
                </div>

                <div class="col-lg-7 mb-4">
                    <div class="row">
                        <div class="col-12">
                            <div class="row no-gutters align-items-center pb-4">
                                <div class="col-md-4 p-1">
                                    <a href="{{ path("addPayment", {"groupId": group.id}) }}"><button type="button" class="btn btn-success pb-2 w-100"><i class="fas fa-money-bill-alt d-block fa-2x mt-2 mb-1 text-gray-300"></i> Ajouter paiement</button></a>
                                </div>
                                <div class="col-md p-1">
                                    <a href="{{ path("groupEdit", {"id": group.id}) }}"><button type="button" class="btn btn-primary pb-2 w-100"><i class="fas fa-edit d-block fa-2x mt-2 mb-1 text-gray-300"></i> Editer</button></a>
                                </div>
                                <div class="col-md p-1">
                                    <a href="{{ path("removeGroup", {"groupId": group.id}) }}"><button type="button" class="btn btn-danger pb-2 w-100"><i class="fas fa-trash d-block fa-2x mt-2 mb-1 text-gray-300"></i> Supprimer</button></a>
                                </div>
                                <div class="col-md p-1">
                                    <a href="{{ path("leaveGroup", {"groupId": group.id, "userId": app.user.id}) }}"><button type="button" class="btn btn-info pb-2 w-100"><i class="fas fa-door-open d-block fa-2x mt-2 mb-1 text-gray-300"></i> Quitter</button></a>
                                </div>
                            </div>
                        </div>
                        <div class="col-lg-5 mb-4">
                            {% if group.payments is empty %}
                            {% else %}
                                <div class="card shadow mb-4">
                                    <div class="card-header py-3">
                                        <h6 class="m-0 font-weight-bold text-success">Le graphique</h6>
                                    </div>
                                    <div class="card-body p-4">
                                        <canvas id="repartitionPie" width="200" height="200"></canvas>
                                    </div>
                                </div>
                            {% endif %}
                        </div>
                        <div class="col-lg-7">
                            <div class="card shadow mb-4">
                                <div class="card-header py-3">
                                    <h6 class="m-0 font-weight-bold text-success">Les Membres</h6>
                                </div>
                                <div class="card-body p-0">
                                    {% for u in group.assoUserGroup %}
                                        {% set userAmount = 0 %}
                                        {% for p in group.payments %}
                                            {% if p.isPaid == false %}
                                                {% if u == p.userWhoNeedToPay %}
                                                    {% set userAmount = userAmount + p.amount %}
                                                {% endif %}
                                            {% endif %}
                                        {% endfor %}
                                        <div class="row no-gutters align-items-center border-bottom px-4 py-3">
                                            <div class="col mr-2">
                                                <div class="text-xs font-weight-bold text-uppercase mb-1">{{ u.firstName}} {{ u.lastName }} <small class="text-lowercase">({{ u.email }})</small></div>
                                            </div>
                                            <div class="col-auto">
                                                <div class="h5 mb-0 font-weight-light text-gray-800">Doit {{ userAmount }}€</div>
                                            </div>
                                        </div>
                                    {% endfor %}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    {% for p in group.payments %}
    <div class="modal fade" id="{{ p.id }}" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLongTitle">{{ p.title }}</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="row">
                        <div class="col-12">
                            <span><strong>A payé:</strong> {{ p.userWhoPaid.firstName }} {{ p.userWhoPaid.lastName }}</span>
                        </div>
                        <div class="col-12">
                            <span><strong>Doit rembourser:</strong> {{ p.userWhoNeedToPay.firstName }} {{ p.userWhoNeedToPay.lastName }}</span>
                        </div>
                        <div class="col-12">
                            <span><strong>Montant:</strong> {{ p.amount }}€</span>
                        </div>
                        <div class="col-12">
                            <span><strong>Date: </strong>{{ p.date|date('d/m/Y') }}</span>
                        </div>
                        <div class="col-12">
                            <span><strong>Remboursé: </strong>{% if p.isPaid == true %}oui{% else %}nope{% endif %}</span>
                        </div>
                        <div class="col-12">
                            <span><strong>Groupe: </strong>{{ p.groupId.title }}</span>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    {% if p.isPaid == false %}
                        {% if p.userWhoNeedToPay == app.user %}
                            <a href="{{ path("refundPayment", {"paymentId": p.id, "previousPage": "detail", "groupId": p.groupId.id}) }}">
                                <button type="button" class="btn btn-success">J'ai remboursé ce paiement</button></a>
                        {% elseif p.userWhoPaid == app.user %}
                            <a href="{{ path("refundPayment", {"paymentId": p.id, "previousPage": "detail", "groupId": p.groupId.id}) }}">
                                <button type="button" class="btn btn-success">Ce paiement a été remboursé</button></a>
                        {% endif %}
                    {% endif %}
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Fermer</button>
                </div>
            </div>
        </div>
    </div>
    {% endfor %}

    {% set paiementsTitle = [] %}
    {% set paiementsValue = [] %}
    {% set tempValue = 0 %}
    {% set previousTitle = "" %}
    {% for p in group.payments %}
        {% if previousTitle != p.title %}
            {% set paiementsTitle = paiementsTitle|merge([p.title]) %}
            {% for pp in group.payments %}
                {% if pp.title == p.title %}
                    {% set tempValue = tempValue + p.amount %}
                {% endif %}
            {% endfor %}
            {% set paiementsValue = paiementsValue|merge([tempValue]) %}
            {% set previousTitle = p.title %}
            {% set tempValue = 0 %}
        {% endif %}
    {% endfor %}

    <script>
        Chart.Legend.prototype.afterFit = function() {
            this.height = this.height + 20;
        };
        var ctx = document.getElementById('repartitionPie').getContext('2d');
        var myChart = new Chart(ctx, {
            type: 'doughnut',
            data: {
                labels: [{% for pTitle in paiementsTitle %}'{{ pTitle }}',{% endfor %}],
                datasets: [{
                    backgroundColor: ['#007bff', '#ffc107', '#28a745', '#17a2b8', '#6610f2', '#fd7e14', '#20c997', '#6f42c1', '#e83e8c', '#dc3545', '#adb5bd'],
                    data: [{% for pValue in paiementsValue %}{{ pValue }},{% endfor %}],
                }]
            },
            options: {
                cutoutPercentage: 80,
                legend: {
                    display: true,
                    position: 'top',
                    labels: {
                        usePointStyle: true,
                    }
                },
            }
        });
    </script>

{% endblock %}
